#include "challenges.h"

Challenges::Challenges()
{
	ifstream fic("challenges.bin", ios::in | ios::binary);
	
	bool conseguido;

	if(!fic.is_open())
	{
		cout << "No existe el fichero de challenges. Creando uno nuevo..." << endl;
		for(int i=0;i<5;i++)
			challenges.push_back(false);
	}
	else
	{
		fic.read((char*)&conseguido, sizeof(bool));
		while(!fic.eof())
		{
			challenges.push_back(conseguido);
			fic.read((char*)&conseguido, sizeof(bool));
		}
		fic.close();
	}
}

Challenges::~Challenges()
{
	ofstream fic("challenges.bin", ios::out | ios::binary);
	
	bool conseguido;

	if(!fic)
		cout << "Se ha producido un error en la apertura del fichero de Challenges" << endl;
	else
	{
		for(unsigned int i=0;i<challenges.size();i++)
		{
			conseguido = challenges[i];
			fic.write((char*)&conseguido, sizeof(bool));
		}
		fic.close();
	}
}

void
Challenges::ejecutar(Datos &datos, int aciertos, int total, int nivel, int puntuacion)
{
	if( (datos.valoresPorDefecto()) && (puntuacion >= 30) && (challenges[0] == false) )
	{
		cout << "Java Challenge accepted and completed! Has conseguido 30 puntos con la configuración por defecto." << endl;
		challenges[0] = true;
	}
	if( (nivel == 9) && (challenges[1] == false) )
	{
		cout << "C++ Challenge accepted and completed! Has terminado la partida con nivel 9" << endl;
		challenges[1] = true;
	}
	if( (datos.valoresPorDefecto()) && (puntuacion >= 50) && (challenges[2] == false) )
	{
		cout << "Assembler Challenge accepted and completed! Has conseguido 50 puntos con la configuración por defecto." << endl;
		challenges[2] = true;
	}
	if( (aciertos == total) && (total >= 15) && (challenges[3] == false) )
	{
		cout << "C++ Challenge accepted and completed! Efectividad del 100% (Al menos 15 operaciones)." << endl;
		challenges[3] = true;
	}
	if( (datos.valoresPorDefecto()) && (nivel == 9) && (challenges[4] == false) )
	{
		cout << "Assembler Challenge accepted and completed! Has terminado la partida con nivel 9 y con la configuración por defecto" << endl;
		challenges[4] = true;
	}
}

void
Challenges::mostrar()
{
	string cadena;
	
	cout << endl;
	cout << "+-------------------------------------------------------------------------------------------------------+" << endl;
	cout << "|:'######::'##::::'##::::'###::::'##:::::::'##:::::::'########:'##::: ##::'######:::'########::'######::|" << endl;
	cout << "|'##... ##: ##:::: ##:::'## ##::: ##::::::: ##::::::: ##.....:: ###:: ##:'##... ##:: ##.....::'##... ##:|" << endl;
	cout << "| ##:::..:: ##:::: ##::'##:. ##:: ##::::::: ##::::::: ##::::::: ####: ##: ##:::..::: ##::::::: ##:::..::|" << endl;
	cout << "| ##::::::: #########:'##:::. ##: ##::::::: ##::::::: ######::: ## ## ##: ##::'####: ######:::. ######::|" << endl;
	cout << "| ##::::::: ##.... ##: #########: ##::::::: ##::::::: ##...:::: ##. ####: ##::: ##:: ##...:::::..... ##:|" << endl;
	cout << "| ##::: ##: ##:::: ##: ##.... ##: ##::::::: ##::::::: ##::::::: ##:. ###: ##::: ##:: ##:::::::'##::: ##:|" << endl;
	cout << "|. ######:: ##:::: ##: ##:::: ##: ########: ########: ########: ##::. ##:. ######::: ########:. ######::|" << endl;
	cout << "|:......:::..:::::..::..:::::..::........::........::........::..::::..:::......::::........:::......:::|" << endl;
	cout << "+------------------------+---------------------------------------------------------------------+--------+" << endl;
	cout << "|  Java challenge!       |  Conseguir 30 puntos con la configuración por defecto               |   ";
	if(challenges[0]) 
		cout << "Sí";
	else
		cout << "No";
	cout << "   |" << endl;
	cout << "|  C++ challenge!        |  Terminar la partida con nivel 9                                    |   ";
	if(challenges[1]) 
		cout << "Sí";
	else
		cout << "No";
	cout << "   |" << endl;
	cout << "|  Assembler challenge!  |  Conseguir 50 puntos con la configuración por defecto               |   ";
	if(challenges[2]) 
		cout << "Sí";
	else
		cout << "No";
	cout << "   |" << endl;
	cout << "|  C++ challenge!        |  Efectividad del 100% (al menos 15 operaciones)                     |   ";
	if(challenges[3]) 
		cout << "Sí";
	else
		cout << "No";
	cout << "   |" << endl;
	cout << "|  Assembler challenge!  |  Terminar la partida con nivel 9 con la configuración por defecto   |   ";
	if(challenges[4]) 
		cout << "Sí";
	else
		cout << "No";
	cout << "   |" << endl;
	cout << "+------------------------+---------------------------------------------------------------------+--------+" << endl;
	cout << endl << "Pulsa Intro para continuar..." << endl;
	getline(cin, cadena);
	system("clear"); 
}

void
Challenges::reset()
{
	challenges.clear();
	for(int i=0;i<5;i++)
		challenges.push_back(false);
}